# !/usr/bin/python2.7
# coding=utf8
from __future__ import print_function
import os
import sys
import argparse
import ConfigParser as configparser
from datetime import datetime

# Добавить дебаг
# https://docs.python.org/3/library/argparse.html

parser = argparse.ArgumentParser(description='Скрипт создания справочника типов документов')
parser.add_argument(
    '--debug',
    dest='debug',
    action='store_const',
    const=True,
    default=False,
    help='включение дебага выводит CSV в терминал, в файл не пишет'
)

config = configparser.ConfigParser()
config.read('/app/asr_billing/cfg/sorm3-mfi/config.ini')

#print(config['folders']['data_dir'])
data_dir = config.get('folders','data_dir')
# Имя файла, можно организовать в 1 строку, 
# но на всякий случай сделано отдельными функциями
currentDate = datetime.today()
dateForFileName = currentDate.strftime("%Y%m%d_%H%M")
outputFileName= data_dir.strip('"') + '/DOC_TYPE_' + dateForFileName + '.txt'

heading = "doc_type_id;begin_time;end_time;description;region_id"
typeList="Паспорт гражданина РФ,Военный билет,Временное удостоверение личности гражданина РФ,Иностранный паспорт,Паспорт гражданина СССР,Свидетельство о регистрации ходатайства иммигранта,Свидетельство о рождении,Справка об освобождении из мест лишения свободы,Удостоверение беженца в РФ,Удостоверение личности офицера,Вид на жительство в РФ иностранных граждан,Загранпаспорт гражданина СССР,Загранпаспорт гражданина РФ,Паспорт Минморфлота,Дипломатический паспорт гражданина РФ,Удостоверение личности,Свидетельство о рождении выданное уполномоченным органом иностранного государства,Паспорт моряка,Иные документы выданные МВД,Неизвестно"

begin_time = "1970-01-01 00:00:00"
end_time = "2030-01-01 23:59:59"

# Дополнить через запятую ID операторов связи, если больше одного
# например: region_id = [3, 1029, 112345]
region_id = [3]


args = parser.parse_args()

# Если дебаг невыключен - пишем в файл, если включен - то в терминал
if not args.debug:
  # Удаляет файл без предупреждения, если он есть! 
  if os.path.exists(outputFileName):
    os.remove(outputFileName)
  # Создаёт и открывает файл txt на запись
  docTypeCSV = open(outputFileName, 'w')
else:
  # Дебаг включен, ыводим в терминал
  docTypeCSV = sys.stdout

# Пишет залоговок в txt
print(heading.upper(), file=docTypeCSV)

# Формирует одинаковый список для всех операторов и пишет в txt
for region in region_id:
    number = 1
    for type in typeList.split(","):
        print(str(number) + ';' + begin_time + ';' + end_time + ';' + type + ';' + str(region), file=docTypeCSV)
        number += 1

# Завершает работу с файлом
docTypeCSV.close()

# Возвращаем скрипту конфигурации путь до файла для вывода в терминал или лог 
print(outputFileName)