set heading off; 
select distinct 
    a.id || ';' ||	--ID 
    coalesce(a.operator_id,'3') || ';' ||	--REGION_ID
    iif(a.create_date is not null
        ,CAST(lpad(EXTRACT(DAY FROM a.create_date),2,'0') AS varchar(2))||'.'|| CAST(lpad(EXTRACT(MONTH FROM a.create_date),2,'0') AS varchar(2))||'.'|| EXTRACT(YEAR FROM a.create_date) || ' 00:00:00'
        ,'31.12.1970 23:59:59'
        ) || ';' ||  --CONTRACT_DATE
	coalesce(a.contract_number,'') || ';' ||	--CONTRACT
	coalesce(a.account_id,'') || ';' ||	--ACCOUNT
    iif(a.create_date is not null
        ,CAST(lpad(EXTRACT(DAY FROM a.create_date),2,'0') AS varchar(2))||'.'|| CAST(lpad(EXTRACT(MONTH FROM a.create_date),2,'0') AS varchar(2))||'.'|| EXTRACT(YEAR FROM a.create_date) || ' 00:00:00'
        ,'31.12.1970 23:59:59'
        ) || ';' ||  ----ACTUAL_FROM

	'31.12.2024 23:59:59' || ';' ||	--ACTUAL_TO
	coalesce(a.company,'') || ';' ||	--ABONENT_TYPE
--<name-info <struct-name> |< unstruct-name>		
--  <struct-name		
	iif(coalesce(a.company,'')=0,'0','1') || ';' ||	--NAME_INFO_TYPE
	'' || ';' ||	--FAMILY_NAME
	'' || ';' ||	--GIVEN_NAME
	'' || ';' ||	--INITIAL_NAME
--  struct-name>		
--  <unstruct-name		
	iif(coalesce(a.company,'0')=0,a.name,'') || ';' ||	--UNSTRUCT_NAME
--  unstruct-name>		
--name-info>		
	coalesce(f_birth.attribute_value,'') || ';' ||	--BIRTH_DATE
    trim(
        case 
            when coalesce(f_d_type.attribute_value,'Паспорт гражданина РФ') = 'Паспорт гражданина РФ' then '1'
            when coalesce(f_d_type.attribute_value,'Паспорт гражданина РФ') = 'Военный билет' then '2'
            when coalesce(f_d_type.attribute_value,'Паспорт гражданина РФ') = 'Временное удостоверение личности гражданина РФ' then '3'
            when coalesce(f_d_type.attribute_value,'Паспорт гражданина РФ') = 'Иностранный паспорт' then '4'
            when coalesce(f_d_type.attribute_value,'Паспорт гражданина РФ') = 'Паспорт гражданина СССР' then '5'
            when coalesce(f_d_type.attribute_value,'Паспорт гражданина РФ') = 'Свидетельство о регистрации ходатайства иммигранта' then '6'
            when coalesce(f_d_type.attribute_value,'Паспорт гражданина РФ') = 'Свидетельство о рождении' then '7'
            when coalesce(f_d_type.attribute_value,'Паспорт гражданина РФ') = 'Справка об освобождении из мест лишения свободы' then '8'
            when coalesce(f_d_type.attribute_value,'Паспорт гражданина РФ') = 'Удостоверение беженца в РФ' then '9'
            when coalesce(f_d_type.attribute_value,'Паспорт гражданина РФ') = 'Удостоверение личности офицера' then '10'
            when coalesce(f_d_type.attribute_value,'Паспорт гражданина РФ') = 'Вид на жительство в РФ иностранных граждан' then '11'
            when coalesce(f_d_type.attribute_value,'Паспорт гражданина РФ') = 'Загранпаспорт гражданина СССР' then '12'
            when coalesce(f_d_type.attribute_value,'Паспорт гражданина РФ') = 'Загранпаспорт гражданина РФ' then '13'
            when coalesce(f_d_type.attribute_value,'Паспорт гражданина РФ') = 'Паспорт Минморфлота' then '14'
            when coalesce(f_d_type.attribute_value,'Паспорт гражданина РФ') = 'Дипломатический паспорт гражданина РФ' then '15'
            when coalesce(f_d_type.attribute_value,'Паспорт гражданина РФ') = 'Удостоверение личности' then '16'
            when coalesce(f_d_type.attribute_value,'Паспорт гражданина РФ') = 'Свидетельство о рождении выданное уполномоченным органом иностранного государства' then '17'
            when coalesce(f_d_type.attribute_value,'Паспорт гражданина РФ') = 'Паспорт моряка' then '18'
            when coalesce(f_d_type.attribute_value,'Паспорт гражданина РФ') = 'Иные документы выданные МВД' then '19'
            when coalesce(f_d_type.attribute_value,'Паспорт гражданина РФ') = 'Неизвестно' then '20'
        else '1'end
    ) || ';' || --IDENT_CARD_TYPE_ID
	'0'	|| ';' || --IDENT_CARD_TYPE
--<ident-card-info <struct-info>|<unstruct-info>		
--  <struct-info 
    iif( coalesce(a.company,'')=0
        ,coalesce(f_d_serial.attribute_value,'') 
        ,''
        ) || ';' || --IDENT_CARD_SERIAL
    iif( coalesce(a.company,'')=0
        ,coalesce(f_d_num.attribute_value,'') 
        ,''
        ) || ';' || --IDENT_CARD_NUMBER
    trim(
        iif( coalesce(a.company,'')=0
            ,coalesce(f_d_otdel.attribute_value,'') || ' ' -- <- Кем выдано и дата - это одно "поле", между ними пригодится пробел
            ,''
            ) || -- <- Кем выдано и дата - это одно "поле", поэтому просто соединяем
        iif( coalesce(a.company,'')=0
            ,coalesce(f_d_date.attribute_value,'') 
            ,''
            )
    ) || ';' || --IDENT_CARD_DESCRIPTION <- trim здесь на случай если оба поля, когда и кем выдано, пустые - пустые
--  struct-info>		
--  <unstruct-info		
	'' || ';' ||	--IDENT_CARD_UNSTRUCT
--unstruct-info>		
--ident-card-info>		 
    iif( coalesce(a.company,'')=1
        ,coalesce(j_bank.attribute_value,'') 
        ,''
        ) || ';' || --BANK		 
    iif( coalesce(a.company,'')=1
        ,coalesce(j_b_acc.attribute_value,'') 
        ,''
        ) || ';' ||	--BANK_ACCOUNT		 
    iif( coalesce(a.company,'')=1
        ,coalesce(j_name.attribute_value,'') 
        ,''
        ) || ';' || --FULL_NAME		 
    iif( coalesce(a.company,'')=1
        ,coalesce(j_inn.attribute_value,'') 
        ,''
        ) || ';' || --INN		 
    iif( coalesce(a.company,'')=1
        ,coalesce(j_contact.attribute_value,'') 
        ,''
        ) || ';' ||	--CONTACT	 
    iif( coalesce(a.company,'')=1
        ,coalesce(j_phone.attribute_value,'') 
        ,''
        ) || ';' || --PHONE_FAX
	coalesce(a.deleted,'0')	|| ';' || --STATUS
    iif(a.activate_date is not null
        ,CAST(lpad(EXTRACT(DAY FROM a.activate_date),2,'0') AS varchar(2))||'.'|| CAST(lpad(EXTRACT(MONTH FROM a.activate_date),2,'0') AS varchar(2))||'.'|| EXTRACT(YEAR FROM a.activate_date) || ' 00:00:00'
        ,'31.12.1970 23:59:59'
        ) || ';' ||  --ATTACH
    iif( coalesce(a.deleted,'0')=1 and a_del_date.block_date is not null 
        ,CAST(lpad(EXTRACT(DAY FROM a_del_date.block_date),2,'0') AS varchar(2))||'.'|| CAST(lpad(EXTRACT(MONTH FROM a_del_date.block_date),2,'0') AS varchar(2))||'.'|| EXTRACT(YEAR FROM a_del_date.block_date) || ' 00:00:00'
        ,''
        ) || ';' || --DETACH
	trim(net_types.n_type) || ';' || --NETWORK_TYPE <- похоже какой-то артефакт case + конкатенация, без trim после числа добалялся пробел вроде ";4 ;"
	a.id || ';' || 	--INTERNAL_ID1
	a.id --INTERNAL_ID2 
from
    abonents a
    -- Телефон
    left join ATTRIBUTE_VALUES as j_phone on a.id=j_phone.ABONENT_ID and j_phone.ATTRIBUTE_ID=1
    -- Наименование 
    left join ATTRIBUTE_VALUES as j_name on a.id=j_name.ABONENT_ID and j_name.ATTRIBUTE_ID=2
    -- ИНН 
    left join ATTRIBUTE_VALUES as j_inn on a.id=j_inn.ABONENT_ID and j_inn.ATTRIBUTE_ID=4
    -- р/c 
    left join ATTRIBUTE_VALUES as j_b_acc on a.id=j_b_acc.ABONENT_ID and j_b_acc.ATTRIBUTE_ID=6
    -- Банк 
    left join ATTRIBUTE_VALUES as j_bank on a.id=j_bank.ABONENT_ID and j_bank.ATTRIBUTE_ID=7
    -- В лице 
    left join ATTRIBUTE_VALUES as j_contact on a.id=j_contact.ABONENT_ID and j_contact.ATTRIBUTE_ID=29
    -- Документ (паспорт и тд), тип
    left join ATTRIBUTE_VALUES as f_d_type on a.id=f_d_type.ABONENT_ID and f_d_type.ATTRIBUTE_ID=-332891
    -- Документ (паспорт и тд), № 
    left join ATTRIBUTE_VALUES as f_d_num on a.id=f_d_num.ABONENT_ID and f_d_num.ATTRIBUTE_ID=13
    -- Документ (паспорт и тд), серия 
    left join ATTRIBUTE_VALUES as f_d_serial on a.id=f_d_serial.ABONENT_ID and f_d_serial.ATTRIBUTE_ID=14
    -- Документ (паспорт и тд), регистрация 
    left join ATTRIBUTE_VALUES as f_d_addr on a.id=f_d_addr.ABONENT_ID and f_d_addr.ATTRIBUTE_ID=15
    -- Документ (паспорт и тд), кем выдан 
    left join ATTRIBUTE_VALUES as f_d_otdel on a.id=f_d_otdel.ABONENT_ID and f_d_otdel.ATTRIBUTE_ID=16
    -- Документ (паспорт и тд), когда выдан 
    left join ATTRIBUTE_VALUES as f_d_date on a.id=f_d_date.ABONENT_ID and f_d_date.ATTRIBUTE_ID=17
    -- Дата рождения 
    left join ATTRIBUTE_VALUES as f_birth on a.id=f_birth.ABONENT_ID and f_birth.ATTRIBUTE_ID=22
left join
    (select distinct
        abonent_id,
        case 
            when ip is not null or (ipv6 is not null and ipv6<>'') then '4' -- стационарные сети передачи данных,
            when phone is not null then '10' -- сеть передачи голосовой информации посредством сети передачи данных
            else '0' -- неконкретизированный стандарт <- предположим, абонентов телематических сервисов нужно указывать тут 
        end n_type
    from 
        users
    ) net_types on a.id=net_types.abonent_id -- <- если у абонента интернет и телефон, будет две отдельные записи в csv. 
        -- можно case уложить в list() и добавить group by abonent_id
        -- тогда будет одна запись с перечислением типов связи, 
        -- но в документации МФИ явно не указано как выгружать таких абонентов
left join
    (select distinct 
        abonent_id,
        cast(b_date as date) block_date
    from 
        abonents_block
    where 
        b_comment='Помещен в корзину') a_del_date on a.id=a_del_date.abonent_id
where 
    a.id>0
    and a.is_folder=0
    and a.master_id is null
    and net_types.n_type != '0' -- Считаем, что пока абонентов только телематики выгружать не требуется 
order by 
    a.id desc 
;